(function() {
  var t, toggle;

  toggle = require("vue-toggle");

  t = {
    template: "<div :class='computedClass'>\n  <label>\n    <slot name='off'>Off</slot>\n    <input type='checkbox' v-model='isOn' v-bind:disabled='disabled'>\n    <span class='lever'></span>\n    <slot name='on'>On</slot>\n  </label>\n</div>",
    mixins: toggle.mixins,
    props: {
      onClass: toggle.props.onClass,
      offClass: toggle.props.offClass,
      isOn: toggle.props.isOn,
      disabled: toggle.props.disabled,
      "class": {
        "default": "switch"
      }
    },
    computed: toggle.computed,
    watch: {
      isOn: function(val) {
        if (val) {
          this.$emit("on");
        } else {
          this.$emit("off");
        }
        return this.$emit("toggle");
      }
    }
  };

  module.exports = t;

}).call(this);
